//************************************************************
//  University of Patras 
//      Department of Electrical Engineering & Computer Technology
//       
//      Course: Parallel Programming in AI 
//      Week 03: Simple c++ programs using threads
//
//        ex5.cpp: Printing Hello World
//      Author: Evangelos Dermatas
//      v0.1
/*
*********************************************************************
gcc -v: gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 18.04
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:      g++ ex5.c -o ex5 -pthread
Executing:      ./ex5

Output in my Laptop:

Hello from main Hello from thread 00 Word
Hello from main 1 Word
 Word
Hello from thread 1 Word
Hello from thread 2 Word
Hello from thread 3 Word
Hello from thread 4 Word
Hello from thread 5 Word
Hello from main Hello from thread 6 Word
Hello from thread 7 Word
Hello from thread 8 Word
Hello from thread 9 Word
2 Word
Hello from main 3 Word
Hello from main 4 Word
Hello from main 5 Word
Hello from main 6 Word
Hello from main 7 Word
Hello from main 8 Word
Hello from main 9 Word

*/

// ***************************************
#include <iostream>
#include <thread>

// ***************************************
using namespace std ;

// ***************************************
void f1(void)
{
for( int i = 0 ; i < 10 ; i++ )
	cout<<"Hello from thread " << i << " Word\n" ;

}


// ***************************************
int main()
{
thread th1(f1) ;
for( int i = 0 ; i < 10 ; i++ )
	cout<<"Hello from main "<< i <<" Word\n" ;
th1.join() ;

return 0 ;
}
