//************************************************************
//  University of Patras 
//      Department of Electrical Engineering & Computer Technology
//       
//      Course: Parallel Programming in AI 
//      Week 03: Simple c++ programs using threads
//
//        ex4.cpp: Printing Hello World
//      Author: Evangelos Dermatas
//      v0.1
/*
*********************************************************************
gcc -v: gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 18.04
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:      g++ ex4.c -o ex4 -pthread
Executing:      ./ex4

Output in my Laptop:

Hello from main Word
Hello from f1 Word

*/

// ***************************************
#include <iostream>
#include <thread>

using namespace std ;

// ***************************************
void f1(void)
{
cout<<"Hello from f1 Word\n" ;
}

// ***************************************
void f2(void)
{
cout<<"Hello from f2 Word\n" ;
}


// ***************************************
int main()
{
thread th1(f1) ;
f2() ;
//cout<<"Hello from main Word\n" ;
th1.join() ;

return 0 ;
}
