//************************************************************
//  University of Patras 
//      Department of Electrical Engineering & Computer Technology
//       
//      Course: Parallel Programming in AI 
//      Week 03: pThreads parallel programming methods
//     
//      pThreads03.c: my Second program, passing parameters 
//      Author: Evangelos Dermatas
//      v0.1
/*
*********************************************************************
gcc -v: gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 18.04
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:      gcc pThreads03.c -o pThreads03 -lpthread
Executing:      ./pThreads03

Output in my Laptop:
Before Thread
Printing 0 2 2
Printing 2 0 0
Printing 1 2 2
After Thread

*********************************************************************
*/

#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h> 
#include <pthread.h> 
  
//************************************************************
void *myThread(void *vargp) 
{ 
	static int i =0 ;
    int d ;
	int k = *((int *) vargp ) ;

    printf("Printing %d %d %d\n", i++, *((int *)vargp), k); 
//    scanf( "%d", &d ) ;
//    sleep(1); 
    return NULL; 
} 


//************************************************************
int main() 
{ 
    pthread_t tid[3]; 
    
    int j ;
    printf("Before Thread\n"); 
    for(  j= 0 ; j < 3 ; j++ )  
    	pthread_create(&(tid[j]), NULL, myThread, (void *) (&j)); 
//    pthread_exit(NULL) ; 
    for(  j= 0 ; j < 3 ; j++ )  
    	pthread_join(tid[j], NULL);
    printf("After Thread\n"); 
    exit(0); 
}

